/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.opennebula.client;

import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;
import org.apache.xmlrpc.XmlRpcException;
import org.apache.xmlrpc.client.XmlRpcClient;
import org.apache.xmlrpc.client.XmlRpcClientConfigImpl;

/**
 *
 * @author tsbatista
 */
public class Client  implements Serializable {

    private User user;
    private String endpoint;
    

    public Client(User user, String endpoint) {
        this.user = user;
        this.endpoint = endpoint;
    }

    public Client(String username, String password, String endpoint) {
        user = new User(username,password);
        this.endpoint = endpoint;
    }

    public OneRpcResponse rpcCall(String method, Object... args) {
        Boolean success = false;
        String msg = null;
        XmlRpcClient client;
        
        XmlRpcClientConfigImpl config = new XmlRpcClientConfigImpl();

        try {
            config.setServerURL(new URL(endpoint));
        } catch (MalformedURLException e) {
            return new OneRpcResponse(false, "The URL " + endpoint + " is malformed.");
        }

        client = new XmlRpcClient();
        client.setConfig(config);


        try {
            Object[] params = new Object[args.length + 1];

            params[0] = user.getSecret();
            System.arraycopy(args, 0, params, 1, args.length);

            Object[] result = (Object[]) client.execute("one." + method, params);

            success = (Boolean) result[0];

            // In some cases, the xml-rpc response only has a boolean
            // OUT parameter
            if (result.length > 1) {
                try {
                    msg = (String) result[1];
                } catch (ClassCastException e) {
                    // The result may be an Integer
                    msg = ((Integer) result[1]).toString();
                }
            }
        } catch (XmlRpcException e) {
            msg = e.getMessage();
        }
        return new OneRpcResponse(success, msg);
    }
}
